
/**
 * Write a description of class TestSum here.
 * 
 * @author (Eric Y. Chou) 
 * @version (V1, 11/20/2015)
 */
public class TestSum
{
   public static void main(String[] args){
        final int PRECISION = 100000; 
       
        // Brute force 
        double sum = 
        0.01 + 0.02 + 0.03 + 0.04 + 0.05 + 0.06 + 0.07 + 0.08 + 0.09 + 0.10 + 
        0.11 + 0.12 + 0.13 + 0.14 + 0.15 + 0.16 + 0.17 + 0.18 + 0.19 + 0.20 + 
        0.21 + 0.22 + 0.23 + 0.24 + 0.25 + 0.26 + 0.27 + 0.28 + 0.29 + 0.30 + 
        0.31 + 0.32 + 0.33 + 0.34 + 0.35 + 0.36 + 0.37 + 0.38 + 0.39 + 0.40 + 
        0.41 + 0.42 + 0.43 + 0.44 + 0.45 + 0.46 + 0.47 + 0.48 + 0.49 + 0.50 + 
        0.51 + 0.52 + 0.53 + 0.54 + 0.55 + 0.56 + 0.57 + 0.58 + 0.59 + 0.60 + 
        0.61 + 0.62 + 0.63 + 0.64 + 0.65 + 0.66 + 0.67 + 0.68 + 0.69 + 0.70 + 
        0.71 + 0.72 + 0.73 + 0.74 + 0.75 + 0.76 + 0.77 + 0.78 + 0.79 + 0.80 + 
        0.81 + 0.82 + 0.83 + 0.84 + 0.85 + 0.86 + 0.87 + 0.88 + 0.89 + 0.90 +
        0.91 + 0.92 + 0.93 + 0.94 + 0.95 + 0.96 + 0.97 + 0.98 + 0.99 + 1.00 ;
        System.out.println("[1] Brute Force sum from 0.01 to 1.0: "+sum); 
        sum = 
        1.00 + 0.99 + 0.98 + 0.97 + 0.96 + 0.95 + 0.94 + 0.93 + 0.92 + 0.91 +
        0.90 + 0.89 + 0.88 + 0.87 + 0.86 + 0.85 + 0.84 + 0.83 + 0.82 + 0.81 +
        0.80 + 0.79 + 0.78 + 0.77 + 0.76 + 0.75 + 0.74 + 0.73 + 0.72 + 0.71 +
        0.70 + 0.69 + 0.68 + 0.67 + 0.66 + 0.65 + 0.64 + 0.63 + 0.62 + 0.61 +
        0.60 + 0.59 + 0.58 + 0.57 + 0.56 + 0.55 + 0.54 + 0.53 + 0.52 + 0.51 +
        0.50 + 0.49 + 0.48 + 0.47 + 0.46 + 0.45 + 0.44 + 0.43 + 0.42 + 0.41 +
        0.40 + 0.39 + 0.38 + 0.37 + 0.36 + 0.35 + 0.34 + 0.33 + 0.32 + 0.31 +
        0.30 + 0.29 + 0.28 + 0.27 + 0.26 + 0.25 + 0.24 + 0.23 + 0.22 + 0.21 +
        0.20 + 0.19 + 0.18 + 0.17 + 0.16 + 0.15 + 0.14 + 0.13 + 0.12 + 0.11 +
        0.10 + 0.09 + 0.08 + 0.07 + 0.06 + 0.05 + 0.04 + 0.03 + 0.02 + 0.01;         
        System.out.println("[2] Brute Force sum from 1.0 to 0.01: "+sum); 
        System.out.println(); 
        
        // looped sum
        sum = 0; 
        for (double x = 0.01; x < 1.005; x += 0.01){
            sum += x; 
        }
        System.out.println("[3] Upward looped sum from 0.01 to 1.0: "+sum); 
        sum = 0; 
        for (double x = 1.0; x > 0.005; x -= 0.01){
            sum += x; 
        }
        System.out.println("[4] Downward looped sum from 1.0 to 0.01: "+sum); 
        System.out.println(); 
        
        // literal f sum
        sum = 0; 
         for (double x = 0.01f; x < 1.005f; x += 0.01f){
            sum += x; 
        }
        System.out.println("[5] Upward looped sum from 0.01f to 1.0f (in literals): "+sum); 
        sum = 0; 
        for (double x = 1.0f; x > 0.005f; x -= 0.01f){
            sum += x; 
        }
        System.out.println("[6] Downward looped sum from 1.0f to 0.01f (in literals): "+sum); 
        System.out.println(); 
        
        // literal d sum
        sum = 0; 
         for (double x = 0.01d; x < 1.005d; x += 0.01d){
            sum += x; 
        }
        System.out.println("[5] Upward looped sum from 0.01d to 1.0d (in literals): "+sum); 
        sum = 0; 
        for (double x = 1.0d; x > 0.005d; x -= 0.01d){
            sum += x; 
        }
        System.out.println("[6] Downward looped sum from 1.0d to 0.01d (in literals): "+sum); 
        System.out.println(); 
              
        // int-loop
        sum = 0; 
        for (int i=1; i<=100; i++){
            sum += i*0.01;  
        }
        System.out.println("[7] Upward int-looped sum from 0.01 to 1.0: "+sum);   
        sum = 0; 
        for (int i=100; i>=1; i--){
            sum += i*0.01;  
        }
        System.out.println("[8] Downward int-looped sum from 1.0 to 0.01: "+sum);    
        System.out.println(); 
        
        // int-loop
        sum = 0; 
        for (int i=1; i<=100; i++){
            sum = sum + i*0.01;  
        }
        System.out.println("[9] Upward int-looped(+) sum from 0.01 to 1.0: "+sum);   
        sum = 0; 
        for (int i=100; i>=1; i--){
            sum = sum + i*0.01;  
        }
        System.out.println("[10] Downward int-looped(+) sum from 1.0 to 0.01: "+sum);  
        System.out.println(); 
        
        // int-loop
        sum = 0; 
        for (int i=1; i<=100; i++){
            sum = Math.round((sum + i*0.01)*PRECISION)/(double) PRECISION;  
        }
        System.out.println("[11] Upward int-looped sum with Quantization Corrected from 0.01 to 1.0: "+sum);   
        sum = 0; 
        for (int i=100; i>=1; i--){
            sum = Math.round((sum + i*0.01)*PRECISION)/(double) PRECISION;  
        }
        System.out.println("[12] Downward int-looped sum with Quantization Correctted from 1.0 to 0.01: "+sum);          
        
        System.out.println(); 
        System.out.println("Conclusion: ");
        System.out.println(" 1. Brute Force Method and Integer-controlled loop provides the best performance. "); 
        System.out.println(" 2. Integer-controlled loop is the best performance and best code efficiency."); 
        System.out.println(" 3. literal d loop is as good as normal literal loop. ");
        System.out.println(" 4. literal f loop has the worst performance due to the precision and loop += operations."); 
        System.out.println(" 5. + operator is more accurate than +=."); 
        System.out.println(" 6. If you know about how much precision you need, use round off correction is the best."); 
        System.out.println("    Downward loop can be corrected to be as good as upward loop.");
        
        
    }
}
